"use strict";

const Promise = require("bluebird");
const pipe = require("@promistream/pipe");
const rangeNumbers = require("@promistream/range-numbers");
const spy = require("./");
const collect = require("@promistream/collect");

Promise.try(() => {
	return pipe([
		rangeNumbers(0, 5),
		spy((number) => console.log(`spied: ${number}`)),
		collect()
	]).read();
}).then((result) => {
	console.log(result);

	/*
		spied: 0
		spied: 1
		spied: 2
		spied: 3
		spied: 4
		[ 0, 1, 2, 3, 4 ]
	*/
});
